#include <fstream>
#include <iostream>
using namespace std;

ifstream fin;
ifstream fout;

int parent[10002], weight[10002];
int n,k;

bool succ()
{  for(int i=1; i<=n; i++)
{
     if(weight[i]>k+1) return false;
}
   return true;
}

int main(int argc, char *argv[])
{

if (argc != 5)
   { cout << "Argument error \n";
     return 0;
   }
   fin.open(argv[1]);    // input file
   if(fin.fail())
   { cout << 0 << endl;
     cout << "Cannot open input file " << argv[1] << endl;
     return 0;
   }


   fout.open(argv[2]);    // output file
   if(fout.fail())
   { cout << 0 << endl;
     cout << "Cannot open output file " << argv[2] << endl;
     return 0;
   }

   ifstream fsol(argv[3]);    // solution file
   if(fsol.fail())
   { cout << 0 << endl;
     cout << "Cannot open solution file " << argv[3] << endl;
     return 0;
   }

  fin>>k; fin>> n;

  parent[1]=0;
  for (int i=2;i<=n;i++)fin>>parent[i];
  fin.close();

  int m;
  fout>>m;
  if(fout.fail())
  { cout << "Empty output file" << endl;
    return 0;
  }

  int x;
  for (int i=0;i<m;i++)
  {  fout>>x;
     for (int j=1;j<=n;j++)
        if (parent[j]==x)parent[j]=0;
  }
  for (int i=0;i<=n;i++)weight[i]=1;
  for (int i=n;i>=1;i--)if (i>0)weight[parent[i]]+=weight[i];

fout.close();
    int p;
    fsol>>p;
fsol.close();

    if(!succ()||(p!=m))
     { cout << "0" << endl;
       cout << "Incorrect" << endl;
       return 0;
     }
   cout<<"10"<<endl;
   cout<<"Correct"<<endl;
   return 0;
}

